//+------------------------------------------------------------------+
//|                                                        RMS_V.mq4 |
//|                                    Copyright  2006, Alex Wilson |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Alex Wilson"
#property link      ""

#property indicator_separate_window
#property  indicator_buffers 4

#property  indicator_color1  Olive
#property  indicator_color2  Red
#property  indicator_color3  Blue
#property  indicator_color4  Green
#property  indicator_width1  2
#property  indicator_width2  2
#property  indicator_width3  1
#property  indicator_width4  1

//
//
//
//
//

extern string TimeFrame = "Current time frame";
extern int    ma1       = 5;
extern int    ma2       = 21;
extern int    ma0       = 55;
extern int    ma4       = 89;

//
//
//
//
//

double ExtBuffer0[];
double ExtBuffer1[];
double ExtBuffer2[];
double ExtBuffer3[];
double ExtBuffer4[];
double slope[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{

   IndicatorBuffers(6);
   SetIndexBuffer(0,ExtBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ExtBuffer3);
   SetIndexBuffer(3,ExtBuffer4);
   SetIndexBuffer(4,ExtBuffer0);
   SetIndexBuffer(5,slope);
   
   //
   //
   //
   //
   //
       
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   calculateValue    = TimeFrame == "calculateValue"; if (calculateValue) return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
          
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+  " RMS_V("+ma1+","+ma2+","+ma0+","+ma4+")");
return(0);
}

//
//
//
//
//

int deinit()  {   return(0);  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { ExtBuffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
   
     for (int i=limit; i>=0; i--)
     {
      
        ExtBuffer3[i] = iMA(Symbol(),0,ma2,0,MODE_EMA,PRICE_CLOSE,i)-iMA(Symbol(),0,ma0,0,MODE_EMA,PRICE_CLOSE,i);
        ExtBuffer4[i] = iMA(Symbol(),0,ma0,0,MODE_EMA,PRICE_CLOSE,i)-iMA(Symbol(),0,ma4,0,MODE_EMA,PRICE_CLOSE,i); 
        ExtBuffer0[i] = iMA(Symbol(),0,ma1,0,MODE_EMA,PRICE_CLOSE,i)-iMA(Symbol(),0,ma0,0,MODE_EMA,PRICE_CLOSE,i);
        ExtBuffer2[i] = EMPTY_VALUE;
        ExtBuffer1[i] = EMPTY_VALUE;
        slope[i] = slope[i+1];
           if (ExtBuffer0[i] > ExtBuffer0[i+1]) slope[i] =  1;
           if (ExtBuffer0[i] < ExtBuffer0[i+1]) slope[i] = -1;
           if (slope[i] ==1)
                 ExtBuffer1[i] = ExtBuffer0[i];
           else  ExtBuffer2[i] = ExtBuffer0[i];
                  
      }
     
      return(0);
      }
       
      //
      //
      //
      //
      //
  
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for (i=limit;i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            ExtBuffer3[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ma1,ma2,ma0,ma4,2,y);
            ExtBuffer4[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ma1,ma2,ma0,ma4,3,y);
            ExtBuffer0[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ma1,ma2,ma0,ma4,4,y);
            slope[i]      = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ma1,ma2,ma0,ma4,5,y);
            ExtBuffer2[i] = EMPTY_VALUE;
            ExtBuffer1[i] = EMPTY_VALUE;
           
            slope[i] = slope[i+1];
            if (ExtBuffer0[i] > ExtBuffer0[i+1]) slope[i] =  1;
            if (ExtBuffer0[i] < ExtBuffer0[i+1]) slope[i] = -1;
            if (slope[i] ==1)
                  ExtBuffer1[i] = ExtBuffer0[i];
            else  ExtBuffer2[i] = ExtBuffer0[i];
           
       }

return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

